const prettyBytes = require('pretty-bytes');
const { takeHeapSnapshot } = require('../../src');

jest.setTimeout(60000);

test('returns a JS heap snapshot with total size', async function () {
  const heapSnapshot = await takeHeapSnapshot('https://unused-css-example-site-qijunirqpu.now.sh');
  const result = prettyBytes(heapSnapshot.totalSize);

  expect(result).toBe('1.54 MB');
});

test('returns the raw snapshot data', async function() {
  const {rawSnapshotData} = await takeHeapSnapshot('https://unused-css-example-site-qijunirqpu.now.sh');

  require('fs').writeFileSync('Heap.heapsnapshot', rawSnapshotData, 'utf8');

  expect(rawSnapshotData).toBeDefined();
});